<ul class="breadcrumb">
    <li><a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a></li>
    <li><?= $this->translate('administration_module_title') ?></li>
    <li class="active"><?= $this->translate('role_module_title') ?></li>
</ul>

<h1 class="page-title">
    <?= $this->icon('role') ?> <?= $this->translate('role_module_title') ?>
</h1>

<div class="row row-padding">
    <div class="col-xs-12">
        <div class="panel" ng-controller="roleListController as self">
            <table-builder options="self.options" items="self.roles" class="table-builder">
                <div class="panel-heading">
                    <?= $this->translate('role_nav_list') ?>
                    <div class="panel-heading-right">
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_remove_from_list') ?>">
                            <?= $this->icon('eraser', 'fa-fw pointer', ['ng-click' => '__tb.removeFromList()']) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_export_xls') ?>">
                            <?= $this->icon('excel', 'fa-fw pointer', ['ng-click' => '__tb.exportExcel()']) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_refresh') ?>">
                            <?= $this->icon('refresh', 'fa-fw pointer', ['ng-click' => '__tb.loadData()']) ?>
                        </div>
                    </div>
                </div>
                <div class="panel-body">
                    <div class="row">
                        <div class="col-sm-4">
                            <div class="table-filters little-panel">
                                <div class="title table-filters-header">
                                    <div class="input-group">
                                        <div class="input-group-addon pointer" data-toggle="collapse" href="#filters-collapsed">
                                            <?= $this->icon('filters', 'fa-fw') ?>
                                            <span class="caret"></span>
                                        </div>
                                        <input type="text" placeholder="<?= $this->translate('search', null, null, false) ?>" class="form-control"
                                               ng-model="self.fullText" id="full-text" on-enter="self.fullTextSearch()"/>
                                        <div class="input-group-addon pointer" ng-click="self.fullTextSearch()">
                                            <?= $this->icon('search', 'fa-fw') ?>
                                        </div>
                                    </div>
                                </div>
                                <div id="filters-collapsed" class="body collapse">
                                    <?php
                                    $filters = [
                                        'id' => [
                                            'label' => $this->translate('role_field_id'),
                                            'type'  => 'string'
                                        ],
                                        'name' => [
                                            'label' => $this->translate('role_field_name'),
                                            'type'  => 'string'
                                        ],
                                        'createdAt' => [
                                            'label' => $this->translate('role_field_createdAt'),
                                            'type'  => 'date'
                                        ],
                                        'updatedAt' => [
                                            'label' => $this->translate('role_field_updatedAt'),
                                            'type'  => 'date'
                                        ],
                                    ];

                                    echo $this->tableFilter('__tb.apiParams.search.data.filters', $filters);
                                    ?>
                                    <div class="row">
                                        <div class="col-xs-6">
                                            <button class="btn" ng-click="self.resetfullTextSearch(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate('table_filter_reset_button') ?></button>
                                        </div>
                                        <div class="col-xs-6 text-right">
                                            <button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
                                                <?= $this->icon('search', 'fa-fw') ?>
                                                <?= $this->translate('table_filter_button') ?>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-sm-4">
                            <table-builder-columns></table-builder-columns>
                        </div>
                        <?php if ($this->acl()->isAllowed('application:e:query:r')) : ?>
                            <div class="col-sm-4">
                                <table-builder-queries></table-builder-queries>
                            </div>
                        <?php endif; ?>
                    </div>
                    <div class="row">
                        <div class="col-xs-12">
                            <form name="roleForm">
                                <table table-builder-table class="table table-bordered table-condensed table-hover">
                                    <thead>
                                        <tr>
                                            <th tb-column tb-name="selection" class="checkbox-column"><input type="checkbox" ng-model="__tb.selection"/></th>
                                            <th tb-column tb-name="id"        tb-toggle="true" tb-sortable="true"><?= $this->translate('role_field_id') ?></th>
                                            <th tb-column tb-name="name"      tb-toggle="true" tb-sortable="true"><?= $this->translate('role_field_name') ?></th>
                                            <th tb-column tb-name="createdAt" tb-toggle="true" tb-sortable="true" tb-hidden="true"><?= $this->translate('user_field_createdAt') ?></th>
                                            <th tb-column tb-name="updatedAt" tb-toggle="true" tb-sortable="true" tb-hidden="true"><?= $this->translate('role_field_updatedAt') ?></th>
                                            <th tb-column tb-name="actions" class="actions-column"></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                            <td colspan="5" class="text-center" ng-if="self.loading">
                                                <?= $this->icon('loading') ?>
                                            </td>
                                        </tr>
                                        <tr ng-repeat="role in self.roles" ng-class="{editing: self.editedLine == role}">
                                            <td><input type="checkbox" ng-model="role.selected"/></td>
                                            <td>{{role.id}}</td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== role">
                                                    <a ng-if="role._rights.read" href="<?= $this->url('role/form') ?>/{{role.id}}">{{role.name}}</a>
                                                    <span ng-if="!role._rights.read">{{role.name}}</span>

                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(role)', 'ng-if' => 'role._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == role">
                                                    <input type="text" name="name" class="form-control input-sm"  ng-model="self.editedLineFields.name" required />
                                                    <field-errors field="name" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td>{{role.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                            <td>{{role.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                            <td>
                                                <div class="btn-group btn-group-actions" ng-if="self.editedLine != role">
                                                    <?php if ($this->acl()->isAllowed('user:e:role:r')) : ?>
                                                    <a href="<?= $this->url('role/form') ?>/{{role.id}}" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_edit') ?>"
                                                       ng-if="role._rights.read">
                                                        <?= $this->icon('edit') ?>
                                                    </a>
                                                    <?php endif; ?>

                                                    <?php if ($this->acl()->isAllowed('user:e:role:d')) : ?>
                                                    <a href="" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>"
                                                       ng-if="role._rights.delete" ng-click="self.deleteRole(role)">
                                                        <?= $this->icon('delete') ?>
                                                    </a>
                                                    <?php endif; ?>
                                                </div>
                                                <div class="btn-group btn-group-actions" ng-if="self.editedLine == role">
                                                    <button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(role)" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
                                                        <?= $this->icon('save') ?>
                                                    </button>
                                                    <button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
                                                        <?= $this->icon('close') ?>
                                                    </button>
                                                </div>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </form>
                        </div>
                    </div>
                </div>
            </table-builder>
        </div>
    </div>
</div>

<?php
    $fabLinks = [];

    if ($this->acl()->isAllowed('user:e:role:c')) {
        $fabLinks[] = [
            'href' => $this->url('role/form'),
            'text' => $this->icon('create', 'fa-fw') . ' ' . $this->translate('role_nav_form')
        ];
    }

    echo $this->fabMenu($fabLinks);
?>

<?php
    $this->angular('js/src/user/service/role.js');
    $this->angular('js/src/application/query/service/query.js');

    $this->angular('js/src/user/controller/roleList.js');
